//+------------------------------------------------------------------+
//|                                                   i-Sessions.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|  16.11.2005                               |
//+------------------------------------------------------------------+
//| Sessions_TRO_MODIFIED_VERSION                                    |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
 
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window

extern bool   Show.Background  = true; 
extern bool   ShowPrice        = false;           //   
extern bool   Show.Trendlines  = true; 

extern int    myBoxWidth   = 3;
extern int    myLineWidth  = 2;

//-------    -------------------------------
extern int    NumberOfDays = 99;             //  
extern string AsiaBegin    = "01:00";        //   
extern string AsiaEnd      = "09:00";        //   
extern color  AsiaColor    = Gold     ;    //   
extern string EurBegin     = "09:00";        //   
extern string EurEnd       = "16:00";        //   
extern color  EurColor     = Maroon;         //   
extern string USABegin     = "14:00";        //   
extern string USAEnd       = "23:00";        //   
extern color  USAColor     = DarkBlue;       //   

//extern color  clFont       = Magenta;           //  
extern color colorHOD      = Red ;
extern color colorOPEN     = DimGray ;
extern color colorLOD      = Blue ;
extern color colorUp       = DeepSkyBlue ;
extern color colorFlat     = DimGray ;
extern color colorDn       = DeepPink ;
extern int    SizeFont     = 8;              //  
extern int    OffSet       = 10;             // 


string TAG = "ses" ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() 
{
  deinit();
  
  for (int i=0; i<NumberOfDays; i++) 
  {
    CreateObjects(TAG+"AS"+i, AsiaColor);
    CreateObjects(TAG+"EU"+i, EurColor);
    CreateObjects(TAG+"US"+i, USAColor);
  }
  
  Comment("");
}

 

//+------------------------------------------------------------------+
//|                                        |
//| :                                                       |
//|   no -                                        |
//|   cl -                                                |
//+------------------------------------------------------------------+
void CreateObjects(string no, color cl) 
{

   if(Show.Background)
   {
      ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
      ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(no, OBJPROP_COLOR, cl);
      ObjectSet(no, OBJPROP_BACK, True);
   }
   else
   {
      ObjectCreate(no+"H", OBJ_TREND, 0, 0,0, 0,0);
      ObjectSet(no+"H", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(no+"H", OBJPROP_COLOR, cl);
      ObjectSet(no+"H", OBJPROP_BACK, True);   
      ObjectSet(no+"H", OBJPROP_RAY, false);       
      ObjectCreate(no+"L", OBJ_TREND, 0, 0,0, 0,0);
      ObjectSet(no+"L", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(no+"L", OBJPROP_COLOR, cl);      
      ObjectSet(no+"L", OBJPROP_BACK, True); 
      ObjectSet(no+"L", OBJPROP_RAY, false);       
      ObjectCreate(no+"O", OBJ_TREND, 0, 0,0, 0,0);
      ObjectSet(no+"O", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(no+"O", OBJPROP_COLOR, cl);      
      ObjectSet(no+"O", OBJPROP_BACK, True); 
      ObjectSet(no+"O", OBJPROP_RAY, false);          
      
         
   } // if         
   
}


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
{
    
   ObDeleteObjectsByPrefix(TAG);  
   Comment("");
      
   return(0);
}
 
//+------------------------------------------------------------------+
void start() 
{
  datetime dt=CurTime();
  
  for (int i=0; i<NumberOfDays; i++) 
  {
    if (ShowPrice && i==0) 
    {
      DrawPrices(dt, "AS", AsiaBegin, AsiaEnd, AsiaColor);
      DrawPrices(dt, "EU", EurBegin, EurEnd, EurColor);
      DrawPrices(dt, "US", USABegin, USAEnd, USAColor);
    }
    
    DrawObjects(dt, "AS"+i, AsiaBegin, AsiaEnd, AsiaColor);
    DrawObjects(dt, "EU"+i, EurBegin, EurEnd, EurColor);
    DrawObjects(dt, "US"+i, USABegin, USAEnd, USAColor);

    dt=decDateTradeDay(dt);

    if(TimeDayOfWeek(dt) == 0){dt=decDateTradeDay(dt);}      
    if(TimeDayOfWeek(dt) == 6){dt=decDateTradeDay(dt);}      
//    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
    
  } // for
} // void

//+------------------------------------------------------------------+
//|                                       |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te, color cl) 
{
  datetime t1, t2, ePlot;
  double   p1, p2, open, close;
  int      b1, b2, hh, ll;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);

  hh=Highest(NULL, 0, MODE_HIGH, b1-b2, b2);
  ll=Lowest (NULL, 0, MODE_LOW , b1-b2, b2);  
  
  p1=High[hh];
  p2=Low [ll];

  open = Open[b1] ;



   if( t2 > Time[0]) { ePlot = Time[0] ; close = Close[0] ;} 
   else              { ePlot = t2 ;      close = Close[b2] ;}  

   if(Show.Trendlines && b1 != b2 && t1 <= Time[0] )
   {
   if(hh > ll ) 
   {
      DrawPriceTrendLines(TAG+no+"OP",t1      , Time[hh] ,open, p1    , colorUp,0, myLineWidth) ;
      DrawPriceTrendLines(TAG+no+"HL",Time[hh], Time[ll] ,p1  , p2    , colorDn,0, myLineWidth) ;
      DrawPriceTrendLines(TAG+no+"CL",Time[ll], ePlot    ,p2  , close , colorUp,0, myLineWidth) ;  
   } 
   else
   {
      DrawPriceTrendLines(TAG+no+"OP",t1      , Time[ll] ,open, p2   , colorDn,0, myLineWidth) ;
      DrawPriceTrendLines(TAG+no+"HL",Time[ll], Time[hh] ,p2  , p1   , colorUp,0, myLineWidth) ;
      DrawPriceTrendLines(TAG+no+"CL",Time[hh], ePlot    ,p1  , close, colorDn,0, myLineWidth) ;  
   } 
   } // if(Show.Trendlines)







   if(Show.Background && t1 <= Time[0] )
   { 
      ObjectSet(TAG+no, OBJPROP_TIME1 , t1);
      ObjectSet(TAG+no, OBJPROP_PRICE1, p1);
      ObjectSet(TAG+no, OBJPROP_TIME2 , t2);
      ObjectSet(TAG+no, OBJPROP_PRICE2, p2);
   }
   else
   {
      if(t1 <= Time[0])
      {
      ObjectSet(TAG+no+"H", OBJPROP_TIME1 , t1);
      ObjectSet(TAG+no+"H", OBJPROP_PRICE1, p1);
      ObjectSet(TAG+no+"H", OBJPROP_TIME2 , ePlot);
      ObjectSet(TAG+no+"H", OBJPROP_PRICE2, p1); 
      ObjectSet(TAG+no+"H",OBJPROP_WIDTH,myLineWidth);   
           
      ObjectSet(TAG+no+"L", OBJPROP_TIME1 , t1);
      ObjectSet(TAG+no+"L", OBJPROP_PRICE1, p2);
      ObjectSet(TAG+no+"L", OBJPROP_TIME2 , ePlot);
      ObjectSet(TAG+no+"L", OBJPROP_PRICE2, p2); 
      ObjectSet(TAG+no+"L",OBJPROP_WIDTH,myLineWidth);  

      ObjectSet(TAG+no+"O", OBJPROP_TIME1 , t1);
      ObjectSet(TAG+no+"O", OBJPROP_PRICE1, open);
      ObjectSet(TAG+no+"O", OBJPROP_TIME2 , ePlot);
      ObjectSet(TAG+no+"O", OBJPROP_PRICE2, open);       
      ObjectSet(TAG+no+"O",OBJPROP_WIDTH,myLineWidth);  
      } // if t1            
   }  // if
} // void

//+------------------------------------------------------------------+
//|                                   |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawPrices(datetime dt, string no, string tb, string te, color cl) 
{
  datetime t1, t2, ePlot;
  double   p1, p2, open;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];

  open = Open[b1] ;
  
     if( t2 > Time[0]) { ePlot = Time[0] ; } else { ePlot = t2 ; }  
 


   
  if(t1 <= Time[0])
  {
  if (ObjectFind(TAG+no+"up")<0) ObjectCreate(TAG+no+"up", OBJ_ARROW, 0, 0,0);
  ObjectSet(TAG+no+"up",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);  
  ObjectSet(TAG+no+"up", OBJPROP_TIME1   , ePlot);
  ObjectSet(TAG+no+"up", OBJPROP_PRICE1  , p1 ); // p1+OffSet*Point)
  ObjectSet(TAG+no+"up", OBJPROP_COLOR   , colorHOD);
  ObjectSet(TAG+no+"up", OBJPROP_FONTSIZE, SizeFont);
//  ObjectSetText(no+"up", DoubleToStr(p1+Ask-Bid, Digits));
  ObjectSetText(TAG+no+"up", DoubleToStr(p1, Digits));
  ObjectSet(TAG+no+"up",OBJPROP_WIDTH,myBoxWidth);  
            
  if (ObjectFind(TAG+no+"dn")<0) ObjectCreate(TAG+no+"dn", OBJ_ARROW, 0, 0,0);
  ObjectSet(TAG+no+"dn",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);  
  ObjectSet(TAG+no+"dn", OBJPROP_TIME1   , ePlot);
  ObjectSet(TAG+no+"dn", OBJPROP_PRICE1  , p2);
  ObjectSet(TAG+no+"dn", OBJPROP_COLOR   , colorLOD);
  ObjectSet(TAG+no+"dn", OBJPROP_FONTSIZE, SizeFont);
  ObjectSetText(TAG+no+"dn", DoubleToStr(p2, Digits));
  ObjectSet(TAG+no+"dn",OBJPROP_WIDTH,myBoxWidth); 
  

  if (ObjectFind(TAG+no+"op")<0) ObjectCreate(TAG+no+"op", OBJ_ARROW, 0, 0,0);
  ObjectSet(TAG+no+"op",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);  
  ObjectSet(TAG+no+"op", OBJPROP_TIME1   , ePlot);
  ObjectSet(TAG+no+"op", OBJPROP_PRICE1  , open);
  ObjectSet(TAG+no+"op", OBJPROP_COLOR   , colorOPEN);
  ObjectSet(TAG+no+"op", OBJPROP_FONTSIZE, SizeFont);
  ObjectSetText(TAG+no+"op", DoubleToStr(open, Digits));
  ObjectSet(TAG+no+"op",OBJPROP_WIDTH,myBoxWidth);  
  } // if
   
} // void

//+------------------------------------------------------------------+
//|                                  |
//| :                                                       |
//|   dt -                                           |
//+------------------------------------------------------------------+
datetime decDateTradeDay (datetime dt) 
{
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) 
  {
    tm--;
    if (tm==0) 
    {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+
 

void DrawPriceTrendLines(string objname, datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, int style, int width)
  {
    
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(objname, OBJPROP_RAY, 0);
 
   ObjectSet(objname, OBJPROP_COLOR, lineColor);
   ObjectSet(objname, OBJPROP_STYLE, style);
   ObjectSet(objname, OBJPROP_WIDTH, width);
  }

//+------------------------------------------------------------------+ 

/*
if( no == "US0")
{
  
Comment(


"no " , no , "\n" ,

"TimeToStr(dt, TIME_DATE)+tb " , TimeToStr(dt, TIME_DATE)+" "+tb , "\n" ,
"TimeToStr(dt, TIME_DATE)+te " , TimeToStr(dt, TIME_DATE)+" "+te , "\n" ,
"t1 " , TimeToStr(t1) , "\n" ,
"Time[0] " , TimeToStr(Time[0]) , "\n" ,
"b1 " , b1 , "\n" ,
"b2 " , b2 , "\n" ,
"hh " , hh , "\n" ,
"ll " , ll , "\n" ,

"t1  " , TimeToStr(t1 ) , "\n" ,
"Time[ll] " , TimeToStr(Time[ll]) , "\n" ,
"Time[hh] " , TimeToStr(Time[hh]) , "\n" ,
"ePlot " , TimeToStr(ePlot) , "\n" ,


"") ;

}


 
 
 

*/